/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/rpc/clnt.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

#ifdef MODULE_ID
/*
 * @(#)clnt.h: $Revision: 1.15.98.1 $ $Date: 95/07/20 10:56:46 $
 * $Locker: indnetwk $
 */
#endif /* MODULE_ID */
/*
 * REVISION: @(#)10.5
 */

#ifndef _RPC_CLNT_INCLUDED
#define _RPC_CLNT_INCLUDED

/*
 * clnt.h - Client side remote procedure call interface.
 *
 * (c) Copyright 1987 Hewlett-Packard Company
 * (c) Copyright 1984 Sun Microsystems, Inc.
 */

#ifndef _SYS_STDSYMS_INCLUDED
#  include <sys/stdsyms.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Rpc calls return an enum clnt_stat.  This should be looked at more,
 * since each implementation is required to live with this (implementation
 * independent) list of errors.
 */
enum clnt_stat {
	RPC_SUCCESS=0,			/* call succeeded */
	/*
	 * local errors
	 */
	RPC_CANTENCODEARGS=1,		/* can't encode arguments */
	RPC_CANTDECODERES=2,		/* can't decode results */
	RPC_CANTSEND=3,			/* failure in sending call */
	RPC_CANTRECV=4,			/* failure in receiving result */
	RPC_TIMEDOUT=5,			/* call timed out */
	/*
	 * remote errors
	 */
	RPC_VERSMISMATCH=6,		/* rpc versions not compatible */
	RPC_AUTHERROR=7,		/* authentication error */
	RPC_PROGUNAVAIL=8,		/* program not available */
	RPC_PROGVERSMISMATCH=9,		/* program version mismatched */
	RPC_PROCUNAVAIL=10,		/* procedure unavailable */
	RPC_CANTDECODEARGS=11,		/* decode arguments error */
	RPC_SYSTEMERROR=12,		/* generic "other problem" */

	/*
	 * callrpc errors
	 */
	RPC_UNKNOWNHOST=13,		/* unknown host name */
	RPC_UNKNOWNPROTO=17,            /* unkown protocol */

	/*
	 * _ create errors
	 */
	RPC_PMAPFAILURE=14,		/* the pmapper failed in its call */
	RPC_PROGNOTREGISTERED=15,	/* remote program is not registered */
	/*
	 * unspecified error
	 */
	RPC_FAILED=16
#ifdef _KERNEL
	/*
	 * Used to process interrupts in kernel calls.
	 */
	, RPC_INTR=18
#endif /*  _KERNEL */
};


/*
 * Error info.
 */
struct rpc_err {
	enum clnt_stat re_status;
	union {
		int RE_errno;		/* realated system error */
		enum auth_stat RE_why;	/* why the auth error occurred */
		struct {
			u_long low;	/* lowest verion supported */
			u_long high;	/* highest verion supported */
		} RE_vers;
		struct {		/* maybe meaningful if RPC_FAILED */
			long s1;
			long s2;
		} RE_lb;		/* life boot & debugging only */
	} ru;
#define	re_errno	ru.RE_errno
#define	re_why		ru.RE_why
#define	re_vers		ru.RE_vers
#define	re_lb		ru.RE_lb
};


/*
 * Client rpc handle.
 * Created by individual implementations, see e.g. rpc_udp.c.
 * Client is responsible for initializing auth, see e.g. auth_none.c.
 */
typedef struct __client {
	AUTH	*cl_auth;			/* authenticator */
	struct clnt_ops {
#ifdef _PROTOTYPES
                enum clnt_stat  (*cl_call)(struct __client *, u_long,
						xdrproc_t, caddr_t, xdrproc_t,
						caddr_t, struct timeval);
		/* call remote procedure */
#ifdef __cplusplus
		void            (*cl_abort)(...);  /* abort a call */
#else
		void            (*cl_abort)();  /* abort a call */
#endif
		void            (*cl_geterr)(struct __client *, 
						struct rpc_err *);
		/* get specific error code */
		bool_t          (*cl_freeres)(struct __client *, xdrproc_t, 
						caddr_t); /* frees results */
		void            (*cl_destroy)(struct __client *);
		/* destroy this structure */
		bool_t          (*cl_control)(struct __client *, int, char *);
		/* the ioctl() of rpc */
#else
#ifdef __cplusplus
		enum clnt_stat	(*cl_call)(...);	/* call remote procedure */
#else
		enum clnt_stat	(*cl_call)();	/* call remote procedure */
#endif
#ifdef __cplusplus
		void		(*cl_abort)(...);	/* abort a call */
#else
		void		(*cl_abort)();	/* abort a call */
#endif
#ifdef __cplusplus
		void		(*cl_geterr)(...);	/* get specific error code */
#else
		void		(*cl_geterr)();	/* get specific error code */
#endif
#ifdef __cplusplus
		bool_t		(*cl_freeres)(...); /* frees results */
#else
		bool_t		(*cl_freeres)(); /* frees results */
#endif
#ifdef __cplusplus
		void		(*cl_destroy)(...);/* destroy this structure */
#else
		void		(*cl_destroy)();/* destroy this structure */
#endif
#ifdef __cplusplus
 		bool_t          (*cl_control)(...);/* the ioctl() of rpc */
#else
 		bool_t          (*cl_control)();/* the ioctl() of rpc */
#endif
#endif
	} *cl_ops;
	caddr_t			cl_private;	/* private stuff */
} CLIENT;


/*
 * client side rpc interface ops
 *
 * Parameter types are:
 *
 */

/*
 * enum clnt_stat
 * CLNT_CALL(rh, proc, xargs, argsp, xres, resp, timeout)
 * 	CLIENT *rh;
 *	u_long proc;
 *	xdrproc_t xargs;
 *	caddr_t argsp;
 *	xdrproc_t xres;
 *	caddr_t resp;
 *	struct timeval timeout;
 */
#define	CLNT_CALL	clnt_call
#define	clnt_call(rh, proc, xargs, argsp, xres, resp, secs)	\
	((*(rh)->cl_ops->cl_call)(rh, proc, xargs, argsp, xres, resp, secs))

/*
 * void
 * CLNT_ABORT(rh) 
 * 	CLIENT *rh;
 */
#define	CLNT_ABORT	clnt_abort
#define	clnt_abort(rh)	((*(rh)->cl_ops->cl_abort)(rh))

/*
 * struct rpc_err
 * CLNT_GETERR(rh) 
 * 	CLIENT *rh;
 */
#define	CLNT_GETERR	clnt_geterr
#define	clnt_geterr(rh,errp)	((*(rh)->cl_ops->cl_geterr)(rh, errp))


/*
 * bool_t
 * CLNT_FREERES(rh, xres, resp) 
 * 	CLIENT *rh;
 *	xdrproc_t xres;
 *	caddr_t resp;
 */
#define	CLNT_FREERES	clnt_freeres
#define	clnt_freeres(rh,xres,resp) ((*(rh)->cl_ops->cl_freeres)(rh,xres,resp))

/*
 * bool_t
 * CLNT_CONTROL(cl, request, info)
 *      CLIENT *cl;
 *      u_int request;
 *      char *info;
 */
#define CLNT_CONTROL(cl,rq,in) ((*(cl)->cl_ops->cl_control)(cl,rq,in))
#define clnt_control(cl,rq,in) ((*(cl)->cl_ops->cl_control)(cl,rq,in))

/*
 * control operations that apply to both udp and tcp transports
 */
#define CLSET_TIMEOUT       1   /* set timeout (timeval) */
#define CLGET_TIMEOUT       2   /* get timeout (timeval) */
#define CLGET_SERVER_ADDR   3   /* get server's address (sockaddr) */
#define CLGET_FD            6   /* get connections file descriptor */
#define CLSET_FD_CLOSE      8   /* close fd while clnt_destroy */
#define CLSET_FD_NCLOSE     9   /* Do not close fd while clnt_destroy */

/*
 * udp only control operations
 */
#define CLSET_RETRY_TIMEOUT 4   /* set retry timeout (timeval) */
#define CLGET_RETRY_TIMEOUT 5   /* get retry timeout (timeval) */


/*
 * void
 * CLNT_DESTROY(rh) 
 * 	CLIENT *rh;
 */
#define	CLNT_DESTROY	clnt_destroy
#define	clnt_destroy(rh)	((*(rh)->cl_ops->cl_destroy)(rh))


/*
 * RPCTEST is a test program which is accessable on every rpc
 * transport/port.  It is used for testing, performance evaluation,
 * and network administration.
 */

#define RPCTEST_PROGRAM		((u_long)1)
#define RPCTEST_VERSION		((u_long)1)
#define RPCTEST_NULL_PROC	((u_long)2)
#define RPCTEST_NULL_BATCH_PROC	((u_long)3)

/*
 * By convention, procedure 0 takes null arguments and returns them
 */

#define NULLPROC ((u_long)0)

/*
 * callrpc(host, prognum, versnum, procnum, inproc, in, outproc, out)
 *      char *host;
 *      int prognum, versnum, procnum;
 *      xdrproc_t inproc, outproc;
 *      char *in, *out;
 */
#ifdef _PROTOTYPES
extern int callrpc (char *, int, int, int, xdrproc_t, char *,
	 	    xdrproc_t, char *);
#else
extern int callrpc ();
#endif

/*
 * Below are the client handle creation routines for the various
 * implementations of client side rpc.  They can return NULL if a 
 * creation failure occurs.
 */

#ifndef _KERNEL
/*
 * Memory based rpc (for speed check and testing)
 * CLIENT *
 * clntraw_create(prog, vers)
 *	u_long prog;
 *	u_long vers;
 */
#ifdef _PROTOTYPES
extern CLIENT *clntraw_create(u_long, u_long);
#else
extern CLIENT *clntraw_create();
#endif

/*
 * TCP based rpc
 * CLIENT *
 * clnttcp_create(raddr, prog, vers, sockp, sendsz, recvsz)
 *	struct sockaddr_in *raddr;
 *	u_long prog;
 *	u_long version;
 *	register int *sockp;
 *	u_int sendsz;
 *	u_int recvsz;
 */
#ifdef _PROTOTYPES
extern CLIENT *clnttcp_create(struct sockaddr_in *, u_long, u_long, 
				int *, u_int, u_int);
#else
extern CLIENT *clnttcp_create();
#endif

/*
 * UDP based rpc.
 * CLIENT *
 * clntudp_create(raddr, program, version, wait, sockp)
 *	struct sockaddr_in *raddr;
 *	u_long program;
 *	u_long version;
 *	struct timeval wait;
 *	int *sockp;
 *
 * Same as above, but you specify max packet sizes.
 * CLIENT *
 * clntudp_bufcreate(raddr, program, version, wait, sockp, sendsz, recvsz)
 *	struct sockaddr_in *raddr;
 *	u_long program;
 *	u_long version;
 *	struct timeval wait;
 *	int *sockp;
 *	u_int sendsz;
 *	u_int recvsz;
 */
#ifdef _PROTOTYPES
extern CLIENT *clntudp_create(struct sockaddr_in *, u_long, u_long,
				struct timeval, int *);
extern CLIENT *clntudp_bufcreate(struct sockaddr_in *, u_long, u_long,
				struct timeval, int *, u_int, u_int);
#else
extern CLIENT *clntudp_create();
extern CLIENT *clntudp_bufcreate();
#endif

/*
 * Generic client creation routine. Supported protocols are "udp" and "tcp"
 * CLIENT *
 * clnt_create(host, prog, vers, prot)
 *      char *host;     -- hostname
 *      u_long prog;    -- program number
 *      u_long vers;    -- version number
 *      char *prot;     -- protocol
 */
#ifdef _PROTOTYPES
extern CLIENT *clnt_create(char *, u_long, u_long, char *);
#else
extern CLIENT *clnt_create();
#endif

/*
 * Generic client creation routine. Supported protocols are which belong
 * to the nettype name space.
 * CLIENT *
 * clnt_create_vers(hostname, prog, vers_out, vers_low, vers_high, proto);
	char *hostname;         -- hostname
	unsigned prog;          -- program number
	unsigned *vers_out;     -- servers highest available version number 
	unsigned vers_low;      -- low version number
	unsigned vers_high;     -- high version number
	char *proto;            -- network type
 */
#ifdef _PROTOTYPES
extern CLIENT * clnt_create_vers(char *, unsigned, unsigned *, unsigned,
					unsigned, char *);
#else
extern CLIENT * clnt_create_vers();
#endif

/*
 * Print why creation failed
 * void 
 * clnt_pcreateerror(msg)        (* stderr *)
 *	char *msg	-- message string to be printed to stderr
 * char *
 * clnt_spcreateerror(msg)      (* string *)
 *	char *msg	-- message string that will get the reason why 
 *			   the create failed added to it
 * int
 * clnt_spcreateerror_r(s, buffer, buflen)   (* string; reentrant *)
 *	char *s;
 *	char *buffer;
 *	int buflen;
 */
#ifdef _PROTOTYPES
void clnt_pcreateerror(char *);
#else  
void clnt_pcreateerror();
#endif

#ifdef _REENTRANT_FUNCTIONS

#ifdef _PROTOTYPES
int clnt_spcreateerror_r(char *, char *, int);
#else  /* _PROTOTYPES */
int clnt_spcreateerror_r();
#endif /* _PROTOTYPES */

#else  /* _REENTRANT_FUNCTIONS */

#ifdef _PROTOTYPES
char *clnt_spcreateerror(char *);
#else  /* _PROTOTYPES */
char *clnt_spcreateerror();
#endif /* _PROTOTYPES */

#endif /* _REENTRANT_FUNCTIONS */

/*
 * Like clnt_perror(), but is more verbose in its output
 * void 
 * clnt_perrno(num);     (* stderr *)
 *	enum clnt_stat num  -- number of the clnt_stat error
 * char *
 * clnt_sperrno(num)     (* string *)
 *      enum clnt_stat num;
 * int
 * clnt_sperrno_r(num, buffer, buflen)   (* string; reentrant *)
 *      enum clnt_stat num;
 *      char *buffer;
 *	int buflen;
 */
#ifdef _PROTOTYPES
void clnt_perrno(enum clnt_stat);
#else
void clnt_perrno();
#endif

#ifdef _REENTRANT_FUNCTIONS

#ifdef _PROTOTYPES
int clnt_sperrno_r(enum clnt_stat, char *, int);
#else  /* _PROTOTYPES */
int clnt_sperrno_r();
#endif /* _PROTOTYPES */

#else  /* _REENTRANT_FUNCTIONS */

#ifdef _PROTOTYPES
char *clnt_sperrno(enum clnt_stat);
#else  /* _PROTOTYPES */
char *clnt_sperrno();
#endif /* _PROTOTYPES */

#endif /* _REENTRANT_FUNCTIONS */

/*
 * clnt_perror prints an English error message, given the client error code
 * clnt_sperror creates the string that is printed by clnt_perror()
 * void 
 * clnt_perror(clnt, msg);        (* stderr *)
 *	CLIENT *clnt;	-- client handle
 *	char *msg;	-- part of the message to be printed
 * char *
 * clnt_sperror(clnt, msg);      (* string *)
 *	CLIENT *clnt;	-- client handle
 *	char *msg;	-- part of the message to be printed.  clnt_sperror
 *			   will add to it
 * int
 * clnt_sperror_r(rpch, s, buffer, buflen);      (* string *)
 *	CLIENT *rpch;	-- client handle
 *	char *s;	
 *	char *buffer;	
 *	int buflen;
 */
#ifdef _PROTOTYPES
void clnt_perror(CLIENT *, char *);
#else
void clnt_perror();
#endif

#ifdef _REENTRANT_FUNCTIONS

#ifdef _PROTOTYPES
int clnt_sperror_r(CLIENT *, char *, char *, int);
#else  /* _PROTOTYPES */
int clnt_sperror_r();
#endif /* _PROTOTYPES */

#else  /* _REENTRANT_FUNCTIONS */

#ifdef _PROTOTYPES
char *clnt_sperror(CLIENT *, char *);
#else  /* _PROTOTYPES */
char *clnt_sperror();
#endif /* _PROTOTYPES */

#endif /* _REENTRANT_FUNCTIONS */



/* 
 * If a creation fails, the following allows the user to figure out why.
 */
struct rpc_createerr {
	enum clnt_stat cf_stat;
	struct rpc_err cf_error; /* useful when cf_stat == RPC_PMAPFAILURE */
};

extern struct rpc_createerr rpc_createerr;

#endif /* !_KERNEL */

#ifdef _KERNEL
/*
 * Kernel udp based rpc
 * CLIENT *
 * clntkudp_create(addr, pgm, vers, retrys, cred)
 *	struct sockaddr_in *addr;
 *	u_long pgm;
 *	u_long vers;
 *      int retrys;
 *      struct ucred *cred;
 */
#ifdef _PROTOTYPES
extern CLIENT *clntkudp_create(struct sockaddr_in *, u_long, u_long,
					int, struct ucred *);
#else
extern CLIENT *clntkudp_create();
#endif /* _PROTOTYPES */

#endif /* _KERNEL */


#define UDPMSGSIZE	8800	/* rpc imposed limit on udp msg size */
#define RPCSMALLMSGSIZE	400	/* a more reasonable packet size */

/*
 * Timers used for the pseudo-transport protocol when using datagrams
 */
/* note this structure has been copied into nfs/nfs_clnt.h */
struct rpc_timers {
       u_short         rt_srtt;        /* smoothed round-trip time */
       u_short         rt_deviate;     /* estimated deviation */
       u_long          rt_rtxcur;      /* current (backed-off) rto */
 };

 /*
  * Feedback values used for possible congestion and rate control
  */

#define       FEEDBACK_REXMIT1        1       /* first retransmit */
#define       FEEDBACK_OK             2       /* no retransmits */

#ifdef	KERNEL
/*
 *	Alloc_xid presents an interface which kernel RPC clients
 *	should use to allocate their XIDs.  Its implementation
 *	may change over time (for example, to allow sharing of
 *	XIDs between the kernel and user-level applications, so
 *	all XID allocation should be done by calling alloc_xid().
 */
extern u_long	clntxid;
#define	alloc_xid()	(clntxid++)
#endif /* KERNEL */

#ifdef __cplusplus
}
#endif

#endif /* _RPC_CLNT_INCLUDED */
