/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/rpc/svc.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

#ifdef MODULE_ID
/*
 * @(#)svc.h: $Revision: 1.12.98.1 $ $Date: 95/07/20 10:57:13 $
 * $Locker: indnetwk $
 */
#endif /* MODULE_ID */
/*
 * REVISION: @(#)10.1
 */

#ifndef _RPC_SVC_INCLUDED
#define _RPC_SVC_INCLUDED

/*
 * svc.h, Server-side remote procedure call interface.
 *
 * (c) Copyright 1987 Hewlett-Packard Company
 * (c) Copyright 1984 Sun Microsystems, Inc.
 */

/*
 * This interface must manage two items concerning remote procedure calling:
 *
 * 1) An arbitrary number of transport connections upon which rpc requests
 * are received.  The two most notable transports are TCP and UDP;  they are
 * created and registered by routines in svc_tcp.c and svc_udp.c, respectively;
 * they in turn call xprt_register and xprt_unregister.
 *
 * 2) An arbitrary number of locally registered services.  Services are
 * described by the following four data: program number, version number,
 * "service dispatch" function, a transport handle, and a boolean that
 * indicates whether or not the exported program should be registered with a
 * local binder service;  if true the program's number and version and the
 * port number from the transport handle are registered with the binder.
 * These data are registered with the rpc svc system via svc_register.
 *
 * A service's dispatch function is called whenever an rpc request comes in
 * on a transport.  The request's program and version numbers must match
 * those of the registered service.  The dispatch function is passed two
 * parameters, struct svc_req * and SVCXPRT *, defined below.
 */

#ifndef _SYS_STDSYMS_INCLUDED
#  include <sys/stdsyms.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

enum xprt_stat {
	XPRT_DIED,
	XPRT_MOREREQS,
	XPRT_IDLE
};

/*
 * Server side transport handle
 */
typedef struct __svcxprt {
#ifdef _KERNEL
	struct socket	*xp_sock;
	struct socket   *xp_sock_out;
#else
	int		xp_sock;
#endif
	u_short		xp_port;	 /* associated port number */
	struct xp_ops {
#ifdef _PROTOTYPES
	    bool_t	(*xp_recv)(struct __svcxprt *, struct rpc_msg *);
			/* receive incoming requests */
	    enum xprt_stat (*xp_stat)(struct __svcxprt *);
			/* get transport status */
	    bool_t	(*xp_getargs)(struct __svcxprt *, xdrproc_t,
					caddr_t); /* get arguments */
	    bool_t	(*xp_reply)(struct __svcxprt *,
				    struct rpc_msg *);	 /* send reply */
	    bool_t	(*xp_freeargs)(struct __svcxprt *, xdrproc_t,
					caddr_t);
			/* free mem allocated for args */
	    void	(*xp_destroy)(struct __svcxprt *);
			/* destroy this struct */
#else
#ifdef __cplusplus
	    bool_t	(*xp_recv)(...);	 /* receive incomming requests */
#else
	    bool_t	(*xp_recv)();	 /* receive incomming requests */
#endif
#ifdef __cplusplus
	    enum xprt_stat (*xp_stat)(...); /* get transport status */
#else
	    enum xprt_stat (*xp_stat)(); /* get transport status */
#endif
#ifdef __cplusplus
	    bool_t	(*xp_getargs)(...); /* get arguments */
#else
	    bool_t	(*xp_getargs)(); /* get arguments */
#endif
#ifdef __cplusplus
	    bool_t	(*xp_reply)(...);	 /* send reply */
#else
	    bool_t	(*xp_reply)();	 /* send reply */
#endif
#ifdef __cplusplus
	    bool_t	(*xp_freeargs)(...);/* free mem allocated for args */
#else
	    bool_t	(*xp_freeargs)();/* free mem allocated for args */
#endif
#ifdef __cplusplus
	    void	(*xp_destroy)(...); /* destroy this struct */
#else
	    void	(*xp_destroy)(); /* destroy this struct */
#endif
#endif /* _PROTOTYPES */
	} *xp_ops;
	int		xp_addrlen;	 /* length of remote address */
	struct sockaddr_in xp_raddr;	 /* remote address */
	struct opaque_auth xp_verf;	 /* raw response verifier */
	caddr_t		xp_p1;		 /* private */
	caddr_t		xp_p2;		 /* private */
	caddr_t		xp_p3;		 /* private */
} SVCXPRT;

/*
 *  Approved way of getting address of caller
 */
#define svc_getcaller(x) (&(x)->xp_raddr)

/*
 * Operations defined on an SVCXPRT handle
 *
 * SVCXPRT		*xprt;
 * struct rpc_msg	*msg;
 * xdrproc_t		 xargs;
 * caddr_t		 argsp;
 */
#define SVC_RECV(xprt, msg)				\
	(*(xprt)->xp_ops->xp_recv)((xprt), (msg))
#define svc_recv(xprt, msg)				\
	(*(xprt)->xp_ops->xp_recv)((xprt), (msg))

#define SVC_STAT(xprt)					\
	(*(xprt)->xp_ops->xp_stat)(xprt)
#define svc_stat(xprt)					\
	(*(xprt)->xp_ops->xp_stat)(xprt)

#define SVC_GETARGS(xprt, xargs, argsp)			\
	(*(xprt)->xp_ops->xp_getargs)((xprt), (xargs), (argsp))
#define svc_getargs(xprt, xargs, argsp)			\
	(*(xprt)->xp_ops->xp_getargs)((xprt), (xargs), (argsp))

#define SVC_REPLY(xprt, msg)				\
	(*(xprt)->xp_ops->xp_reply) ((xprt), (msg))
#define svc_reply(xprt, msg)				\
	(*(xprt)->xp_ops->xp_reply) ((xprt), (msg))

#define SVC_FREEARGS(xprt, xargs, argsp)		\
	(*(xprt)->xp_ops->xp_freeargs)((xprt), (xargs), (argsp))
#define svc_freeargs(xprt, xargs, argsp)		\
	(*(xprt)->xp_ops->xp_freeargs)((xprt), (xargs), (argsp))

#define SVC_DESTROY(xprt)				\
	(*(xprt)->xp_ops->xp_destroy)(xprt)
#define svc_destroy(xprt)				\
	(*(xprt)->xp_ops->xp_destroy)(xprt)


/*
 * Service request
 */
struct svc_req {
	u_long		rq_prog;	/* service program number */
	u_long		rq_vers;	/* service protocol version */
	u_long		rq_proc;	/* the desired procedure */
	struct opaque_auth rq_cred;	/* raw creds from the wire */
	caddr_t		rq_clntcred;	/* read only cooked cred */
	struct __svcxprt *rq_xprt;	/* associated transport */
};


/*
 * Server statistics
  */
struct rsstatstr {
	  int     rscalls;
	  int     rsbadcalls;
	  int     rsnullrecv;
	  int     rsbadlen;
	  int     rsxdrcall;
	  int     rsruns;
};

#define STATISTICS_ON 1
#ifdef STATISTICS_ON
#define RSSTAT(x) rsstat.x
#else
#define RSSTAT(x)
#endif

/*
 * Service registration
 *
 * svc_register(xprt, prog, vers, dispatch, protocol)
 *	SVCXPRT *xprt;
 *	u_long prog;
 *	u_long vers;
#ifdef __cplusplus
 *	void (*dispatch)(...);
#else
 *	void (*dispatch)();
#endif
 *	int protocol;  */ /* like TCP or UDP, zero means do not register 
 */

#ifdef _PROTOTYPES
extern bool_t	svc_register(SVCXPRT *, u_long, u_long, 
			     void (*)(struct svc_req *, SVCXPRT *), int);
#else
extern bool_t	svc_register();
#endif

/*
 * Service un-registration
 *
 * svc_unregister(prog, vers)
 *	u_long prog;
 *	u_long vers;
 */

#ifdef _PROTOTYPES
extern void	svc_unregister(u_long, u_long);
#else
extern void	svc_unregister();
#endif

/*
 * Transport registration.
 *
 * xprt_register(xprt)
 *	SVCXPRT *xprt;
 */

#ifdef _PROTOTYPES
extern void	xprt_register(SVCXPRT *);
#else
extern void	xprt_register();
#endif

#ifndef _KERNEL
/*
 * Transport un-register
 *
 * xprt_unregister(xprt)
 *	SVCXPRT *xprt;
 */

#ifdef _PROTOTYPES
extern void	xprt_unregister(SVCXPRT *);
#else
extern void	xprt_unregister();
#endif

#endif /* !_KERNEL */


/*
 * When the service routine is called, it must first check to see if it
 * knows about the procedure;  if not, it should call svcerr_noproc
 * and return.  If so, it should deserialize its arguments via 
 * SVC_GETARGS (defined above).  If the deserialization does not work,
 * svcerr_decode should be called followed by a return.  Successful
 * decoding of the arguments should be followed the execution of the
 * procedure's code and a call to svc_sendreply.
 *
 * Also, if the service refuses to execute the procedure due to too-
 * weak authentication parameters, svcerr_weakauth should be called.
 * Note: do not confuse access-control failure with weak authentication!
 *
 * NB: In pure implementations of rpc, the caller always waits for a reply
 * msg.  This message is sent when svc_sendreply is called.  
 * Therefore pure service implementations should always call
 * svc_sendreply even if the function logically returns void;  use
 * xdr.h - xdr_void for the xdr routine.  HOWEVER, tcp based rpc allows
 * for the abuse of pure rpc via batched calling or pipelining.  In the
 * case of a batched call, svc_sendreply should NOT be called since
 * this would send a return message, which is what batching tries to avoid.
 * It is the service/protocol writer's responsibility to know which calls are
 * batched and which are not.  Warning: responding to batch calls may
 * deadlock the caller and server processes!
 */


#ifdef _PROTOTYPES
extern bool_t   svc_sendreply(SVCXPRT *, xdrproc_t, caddr_t);
extern void	svcerr_decode(SVCXPRT *);
extern void	svcerr_weakauth(SVCXPRT *);
extern void	svcerr_noproc(SVCXPRT *);
extern void     svcerr_progvers(SVCXPRT *, u_long, u_long);
extern void     svcerr_auth(SVCXPRT *, enum auth_stat);
extern void     svcerr_noprog(SVCXPRT *);
extern void     svcerr_systemerr(SVCXPRT *);
#else
extern bool_t   svc_sendreply();
extern void	svcerr_decode();
extern void	svcerr_weakauth();
extern void	svcerr_noproc();
extern void     svcerr_progvers();
extern void     svcerr_auth();
extern void     svcerr_noprog();
extern void     svcerr_systemerr();
#endif

/*
 * Lowest level dispatching -OR- who owns this process anyway.
 * Somebody has to wait for incoming requests and then call the correct
 * service routine.  The routine svc_run does infinite waiting; i.e.,
 * svc_run never returns.
 * Since another (co-existant) package may wish to selectively wait for
 * incoming calls or other events outside of the rpc architecture, the
 * routine svc_getreq is provided.  It must be passed readfds, the
 * "in-place" results of a select system call (see select, section 2).
 */

#ifndef _KERNEL
/*
 * Global keeper of rpc service descriptors in use
 * dynamic; must be inspected before each call to select
*/

extern fd_set svc_fdset;
#define svc_fds svc_fdset.fds_bits[0]        /* compatibility */

/*
 * a small program implemented by the svc_rpc implementation itself;
 * also see clnt.h for protocol numbers.
 */
extern void rpctest_service();
#endif /* !_KERNEL */

#ifdef _PROTOTYPES

#ifdef _KERNEL
extern void	svc_getreq(SVCXPRT *);
extern void     svc_getreqset(SVCXPRT *); /* similar to svc_getreq except  */
                                   	 /* that it takes a fdset instead */
                                   	 /* of an int for its argument.   */
extern void	svc_run(SVCXPRT *); 	 /* never returns */
#else
extern void	svc_getreq(int);
extern void     svc_getreqset(fd_set *); /* calls svc_getreqset_ms */
extern void     svc_getreqset_ms(fd_set *, long); 
					 /* similar to svc_getreq except  */
                                   	 /* that it takes a fdset instead */
                                   	 /* of an int for its argument.   */
extern void	svc_run(void); 	 	 /* calls svc_run_ms; never returns */
extern void	svc_run_ms(long); 	 /* never returns */
#endif /* _KERNEL */

#else /* _PROTOTYPES */
extern void	svc_getreq();
extern void     svc_getreqset();  
extern void	svc_run(); 

#ifndef _KERNEL
extern void     svc_getreqset_ms();  
extern void	svc_run_ms(); 	   
#endif /* !_KERNEL */

#endif /* _PROTOTYPES */


/*
 * Socket to use on svcxxx_create call to get default socket
 */
#define	RPC_ANYSOCK	(-1)

/*
 * These are the existing service side transport implementations
 */

#ifndef _KERNEL
/*
 * Memory based rpc for testing and timing.
 */
#ifdef _PROTOTYPES
extern SVCXPRT *svcraw_create(void);
#else
extern SVCXPRT *svcraw_create();
#endif

/*
 * Udp based rpc.
 */
#ifdef _PROTOTYPES
extern SVCXPRT *svcudp_create(int);
extern SVCXPRT *svcudp_bufcreate(int, u_int, u_int);
#else
extern SVCXPRT *svcudp_create();
extern SVCXPRT *svcudp_bufcreate();
#endif

/*
 * Tcp based rpc.
 */
#ifdef _PROTOTYPES
extern SVCXPRT *svctcp_create(int, u_int, u_int);
extern SVCXPRT *svcfd_create (int, u_int, u_int);
#else
extern SVCXPRT *svctcp_create();
extern SVCXPRT *svcfd_create ();
#endif

#else /* !_KERNEL */

/*
 * Kernel udp based rpc.
 */
#ifdef _PROTOTYPES
extern SVCXPRT *svckudp_create(struct socket *, u_short);
#else
extern SVCXPRT *svckudp_create();
#endif

#endif /* !_KERNEL */

#ifdef __cplusplus
}
#endif

#endif /* !_RPC_SVC_INCLUDED */
